summaryrefslogtreecommitdiffstats
path: root/libraries
diff options
context:
space:
mode:
author Andre Barboza <bmg.andre@gmail.com>2017-01-17 06:24:36 +0700
committer Willy Sudiarto Raharjo <willysr@slackbuilds.org>2017-01-20 19:35:20 +0700
commitcf74ad14b3542096ea4907ac92d32a59efcaf5fb (patch)
tree7af39ec6f768f92829efd47fd7a824abe62dcf19 /libraries
parentaad6a81bfa4c42a1081176da7caf0e8bb6a36fec (diff)
downloadslackbuilds-cf74ad14b3542096ea4907ac92d32a59efcaf5fb.tar.gz
slackbuilds-cf74ad14b3542096ea4907ac92d32a59efcaf5fb.tar.xz
libraries/rocksdb: Added (persistent key-value store).
Signed-off-by: Willy Sudiarto Raharjo <willysr@slackbuilds.org>
Diffstat (limited to 'libraries')
-rw-r--r--libraries/rocksdb/README31
-rw-r--r--libraries/rocksdb/rocksdb.SlackBuild146
-rw-r--r--libraries/rocksdb/rocksdb.info10
-rw-r--r--libraries/rocksdb/slack-desc19
4 files changed, 206 insertions, 0 deletions
diff --git a/libraries/rocksdb/README b/libraries/rocksdb/README
new file mode 100644
index 0000000000..2ba46d5b31
--- /dev/null
+++ b/libraries/rocksdb/README
@@ -0,0 +1,31 @@
+RocksDB is a C++ library providing an embedded key-value store, where
+keys and values are arbitrary byte streams. It was developed at
+Facebook based on LevelDB and provides backwards-compatible support
+for LevelDB APIs.
+
+RocksDB is optimized for Flash with extremely low latencies. RocksDB
+uses a Log Structured Database Engine for storage, written entirely in
+C++. A Java version called RocksJava is currently in development.
+
+RocksDB features highly flexible configuration settings that may be
+tuned to run on a variety of production environments, including pure
+memory, Flash, hard disks or HDFS. It supports various compression
+algorithms and good tools for production support and debugging.
+
+Features:
+- Designed for application servers wanting to store up to a few
+ terabytes of data on locally attached Flash drives or in RAM
+- Optimized for storing small to medium size key-values on fast
+ storage -- flash devices or in-memory
+- Scales linearly with number of CPUs so that it works well on
+ processors with many cores
+
+Build Options:
+- BUILD_TYPE=(all|lite|UNSET): if unset the default librocksdb will
+ build; set it to lite to build only librocksdb_lite; if it is set to
+ all, it will build both librocksdb and librocksdb_lite.
+ Default is unset.
+- ENABLE_STATIC=(yes|no): Deploy static library besides shared.
+ Default is no.
+- INSTALL_TOOLS=(yes|no): Deploy administration tools.
+ Default is yes.
diff --git a/libraries/rocksdb/rocksdb.SlackBuild b/libraries/rocksdb/rocksdb.SlackBuild
new file mode 100644
index 0000000000..c3072d88fc
--- /dev/null
+++ b/libraries/rocksdb/rocksdb.SlackBuild
@@ -0,0 +1,146 @@
+#!/bin/sh
+
+# Slackware build script for Facebook RocksDB
+
+# Copyright 2017 Andre Barboza, Belo Horizonte - Brazil
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR "AS IS" AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+PRGNAM=rocksdb
+VERSION=${VERSION:-5.0.1}
+BUILD=${BUILD:-1}
+TAG=${TAG:-_SBo}
+
+if [ -z "$ARCH" ]; then
+ case "$( uname -m )" in
+ i?86) ARCH=i586 ;;
+ arm*) ARCH=arm ;;
+ *) ARCH=$( uname -m ) ;;
+ esac
+fi
+
+CWD=$(pwd)
+TMP=${TMP:-/tmp/SBo}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+if [ "$ARCH" = "i586" ]; then
+ SLKCFLAGS="-O2 -march=i586 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "i686" ]; then
+ SLKCFLAGS="-O2 -march=i686 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "x86_64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+ LIBDIRSUFFIX="64"
+else
+ SLKCFLAGS="-O2"
+ LIBDIRSUFFIX=""
+fi
+
+set -e
+
+rm -rf $PKG
+mkdir -p $TMP $PKG $OUTPUT
+cd $TMP
+rm -rf $PRGNAM-$VERSION
+tar xvf $CWD/$PRGNAM-$VERSION.tar.gz
+cd $PRGNAM-$VERSION
+chown -R root:root .
+find -L . \
+ \( -perm 777 -o -perm 775 -o -perm 750 -o -perm 711 -o -perm 555 \
+ -o -perm 511 \) -exec chmod 755 {} \; -o \
+ \( -perm 666 -o -perm 664 -o -perm 640 -o -perm 600 -o -perm 444 \
+ -o -perm 440 -o -perm 400 \) -exec chmod 644 {} \;
+
+CXXFLAGS="-fdata-sections -ffunction-sections"
+LDFLGAS="-Wl,--gc-sections"
+if [ "$BUILD_TYPE" == "all" ] || [ "$BUILD_TYPE" != "lite" ] ; then
+ DEBUG_LEVEL=0 \
+ EXTRA_CXXFLAGS="$SLKCFLAGS $CXXFLAGS" \
+ EXTRA_LDFLAGS="$LDFLAGS" \
+ make shared_lib
+
+ if [ "${ENABLE_STATIC:-no}" == "yes" ]; then
+ INSTALL_PATH=$PKG/usr \
+ make install
+ else
+ INSTALL_PATH=$PKG/usr \
+ make install-shared
+ fi
+fi
+
+# rocksdb lite
+if [ "$BUILD_TYPE" == "all" ] || [ "$BUILD_TYPE" == "lite" ]; then
+ DEBUG_LEVEL=0 \
+ EXTRA_CXXFLAGS="$SLKCFLAGS $CXXFLAGS" \
+ EXTRA_LDFLAGS="$LDFLAGS" \
+ OPT=-DROCKSDB_LITE=1 \
+ LIBNAME=librocksdb_lite \
+ make shared_lib
+
+ if [ "${ENABLE_STATIC:-no}" == "yes" ]; then
+ OPT=-DROCKSDB_LITE=1 \
+ LIBNAME=librocksdb_lite \
+ INSTALL_PATH=$PKG/usr \
+ make install
+ else
+ OPT=-DROCKSDB_LITE=1 \
+ LIBNAME=librocksdb_lite \
+ INSTALL_PATH=$PKG/usr \
+ make install-shared
+ fi
+fi
+
+# fix lib dir
+[ ! -z "$LIBDIRSUFFIX" ] && mv $PKG/usr/lib $PKG/usr/lib${LIBDIRSUFFIX}
+
+# build and install adm tools
+if [ "${INSTALL_TOOLS:-yes}" == "yes" ]; then
+ DEBUG_LEVEL=0 \
+ EXTRA_CXXFLAGS="$SLKCFLAGS $CXXFLAGS" \
+ EXTRA_LDFLAGS="$LDFLAGS" \
+ make tools
+
+ mkdir -p $PKG/usr/bin
+ install -m755 db_repl_stress $PKG/usr/bin/db_repl_stress
+ install -m755 db_sanity_test $PKG/usr/bin/db_sanity_test
+ install -m755 db_stress $PKG/usr/bin/db_stress
+ install -m755 ldb $PKG/usr/bin/ldb
+ install -m755 rocksdb_dump $PKG/usr/bin/rocksdb_dump
+ install -m755 rocksdb_undump $PKG/usr/bin/rocksdb_undump
+ install -m755 sst_dump $PKG/usr/bin/sst_dump
+ install -m755 write_stress $PKG/usr/bin/write_stress
+fi
+
+find $PKG -print0 | xargs -0 file | grep -e "executable" -e "shared object" | grep ELF \
+ | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
+
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+cp -a AUTHORS CONTRIBUTING.md DUMP_FORMAT.md INSTALL.md LICENSE README.md USERS.md \
+ DEFAULT_OPTIONS_HISTORY.md HISTORY.md LANGUAGE-BINDINGS.md PATENTS \
+ ROCKSDB_LITE.md WINDOWS_PORT.md \
+ $PKG/usr/doc/$PRGNAM-$VERSION
+cat $CWD/$PRGNAM.SlackBuild > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+
+cd $PKG
+/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.${PKGTYPE:-tgz}
diff --git a/libraries/rocksdb/rocksdb.info b/libraries/rocksdb/rocksdb.info
new file mode 100644
index 0000000000..e18c84eb62
--- /dev/null
+++ b/libraries/rocksdb/rocksdb.info
@@ -0,0 +1,10 @@
+PRGNAM="rocksdb"
+VERSION="5.0.1"
+HOMEPAGE="http://rocksdb.org"
+DOWNLOAD="https://github.com/facebook/rocksdb/archive/v5.0.1/rocksdb-5.0.1.tar.gz"
+MD5SUM="e5443504b430c71c04f19f13ebc89a4b"
+DOWNLOAD_x86_64=""
+MD5SUM_x86_64=""
+REQUIRES="snappy gflags"
+MAINTAINER="Andre Barboza"
+EMAIL="bmg.andre@gmail.com"
diff --git a/libraries/rocksdb/slack-desc b/libraries/rocksdb/slack-desc
new file mode 100644
index 0000000000..5338786ad1
--- /dev/null
+++ b/libraries/rocksdb/slack-desc
@@ -0,0 +1,19 @@
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description.
+# Line up the first '|' above the ':' following the base package name, and
+# the '|' on the right side marks the last column you can put a character in.
+# You must make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':' except on otherwise blank lines.
+
+ |-----handy-ruler------------------------------------------------------|
+rocksdb: rocksdb (Embeddable, persistent key-value store for fast storage)
+rocksdb:
+rocksdb: This library forms the core building block for a fast key value
+rocksdb: server, especially suited for storing data on flash drives. It has
+rocksdb: a Log-Structured-Merge-Database (LSM) design with flexible
+rocksdb: tradeoffs between Write-Amplification-Factor (WAF),
+rocksdb: Read-Amplification-Factor (RAF) and Space-Amplification-Factor (SAF).
+rocksdb: It has multi-threaded compactions, making it specially suitable for
+rocksdb: storing multiple terabytes of data in a single database.
+rocksdb:
+rocksdb: http://rocksdb.org